<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-12 py-2 col-sm-12">
            <label for="input-large">Kode Projek</label>

            <b-form-select
              v-model="filter.code"
              :options="formattedProjectOptions"
              size="lg"
              @change="setNickname($event)"
            ></b-form-select>
          </div>

          <div class="col-md-12 py-2 col-sm-12">
            <label for="input-large">Nama Proyek</label>

            <b-form-input
              v-model="filter.nickname"
              disabled
              size="lg"
            ></b-form-input>
          </div>
        </div>

        <div class="d-flex justify-content-end mt-5">
          <div class="d-flex">
            <button class="btn btn-primary btn-md mr-2" @click="getReports()">
              Tampilkan Seluruhnya
            </button>
          </div>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row mb-5">
          <div class="col-md-4 py-2 col-sm-12">
            <button class="btn btn-success btn-md mr-2">
              <i class="flaticon2-download" /> Excel
            </button>

            <button class="btn btn-secondary btn-md mr-2">
              <i class="flaticon2-download" />  PDF
            </button>
          </div>

          <div class="col-md-4 offset-md-4 py-2 col-sm-12">
            <div class="input-group">
              <div class="input-group-prepend">
                <span class="input-group-text">
                  <i class="flaticon2-search-1"></i>
                </span>
              </div>

              <input type="text" class="form-control" placeholder="Search" />
            </div>
          </div>
        </div>

        <complete-table :loading="loading" :data="distributionLogistics">
          <template #header>
            <tr class="text-left">
              <th style="min-width: 200px" class="pl-7">
                <span class="text-dark-75">No</span>
              </th>
              <th style="min-width: 150px">Numbering</th>
              <th style="min-width: 150px">Title</th>
              <th style="min-width: 150px">Stasiun</th>
              <th style="min-width: 150px">Scope</th>
              <th style="min-width: 150px">Type</th>
              <th style="min-width: 150px">Date</th>
              <th style="min-width: 150px">Status</th>
              <th style="min-width: 150px">Revision</th>
              <th style="min-width: 150px">Version</th>
              <th style="min-width: 150px">Receiver</th>
              <th style="min-width: 150px">Distribution Date</th>
            </tr>
          </template>

          <template #body>
            <template
              v-for="(distributionLogistic, i) in distributionLogistics"
            >
              <tr v-bind:key="i" class="border-0">
                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ i + 1 }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ distributionLogistic.numbering }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ distributionLogistic.title }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{
                      distributionLogistic.station
                        ? distributionLogistic.station.name
                        : "-"
                    }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{
                      distributionLogistic.scope
                        ? distributionLogistic.scope.name
                        : "-"
                    }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{
                      distributionLogistic.type
                        ? distributionLogistic.type.name
                        : "-"
                    }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ distributionLogistic.date_receive }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{
                      distributionLogistic.last_status
                        ? distributionLogistic.last_status.code
                        : "-"
                    }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{
                      distributionLogistic.revision_version
                    }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{
                      distributionLogistic.numbering
                    }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{
                      distributionLogistic.receiver
                    }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{
                      distributionLogistic.transmittal_date
                    }}
                  </span>
                </td>
              </tr>
            </template>
          </template>
        </complete-table>
      </div>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "../../../core/services/store/breadcrumbs.module";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";
import { mapState } from "vuex";
import { arrayMoreThanOne } from "../../../core/helper/array-validation.helper";
import { GET_PROJECT_DETAIL } from "../../../core/services/store/project.module";
import { GET_SCOPES } from "../../../core/services/store/scope.module";
import { showToast } from "../../../core/helper/toast.helper";
import { GET_DISTRIBUTION_LOGISTIC } from "../../../core/services/store/reporting-distribution-logistic.module";

export default {
  components: { CompleteTable },
  data() {
    return {
      filter: {
        code: null,
        nickname: null,
        scope: null,
        revision_version: null
      },
      data: [
        {
          id: 123,
          site_document_type: {
            code: "asd",
            name: "asbuilt drawing",
            category: {
              code: "asd",
              name: "category name"
            }
          },
          project: {
            code: "LSR123123",
            name: "project name",
            nickname: "makpar 2"
          },
          complete: 0,
          storage: "/path/to/file.txt"
        },
        {
          id: 123,
          site_document_type: {
            code: "asd",
            name: "asbuilt drawing",
            category: {
              code: "asd",
              name: "category name"
            }
          },
          project: {
            code: "LSR123123",
            name: "project name",
            nickname: "makpar 2"
          },
          complete: 1,
          storage: "/path/to/file.txt"
        }
      ]
    };
  },
  computed: {
    ...mapState({
      projects: state => state.projectDetails.projectDetails?.data,
      scopes: state => state.scope.scopes?.data,
      distributionLogistics: state =>
        state.reportingDistributionLogistic.distributionLogistics?.data,
      loading: state => state.reportingDistributionLogistic.loading
    }),

    formattedProjectOptions() {
      let projects = [];

      if (arrayMoreThanOne(this.projects)) {
        projects = this.projects.map(project => {
          return {
            value: project.code,
            text: project.code
          };
        });
      }

      return [{ value: null, text: "Pilih Nickname" }, ...projects];
    },

    formattedScopeOptions() {
      let scopes = [];

      if (arrayMoreThanOne(this.scopes)) {
        scopes = this.scopes.map(scope => {
          return {
            value: scope.code,
            text: scope.name
          };
        });
      }

      return [{ value: null, text: "Pilih Scope" }, ...scopes];
    }
  },
  methods: {
    getProjects() {
      if (!arrayMoreThanOne(this.projects)) {
        this.$store.dispatch(GET_PROJECT_DETAIL, "design");
      }
    },

    getScopes() {
      if (!arrayMoreThanOne(this.scopes)) {
        this.$store.dispatch(GET_SCOPES, {});
      }
    },

    getReports() {
      if (this.filter.code) {
        this.$store.dispatch(GET_DISTRIBUTION_LOGISTIC, {
          params: {
            ...this.filter
          },
          code: this.filter?.code
        });
      } else {
        showToast("Gagal", "Pilih projek terlebih dahulu", "danger");
      }
    },

    setNickname(value) {
      const project = this.projects?.find(project => project?.code === value);

      this.filter.nickname = project?.nickname;

      this.filter.revision_version = project?.dmp_rev;
    }
  },
  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [
      { title: "Report Distribusi Logistik" }
    ]);

    this.getProjects();

    this.getScopes();
  }
};
</script>
